#include <iostream>
#include "Employee.h"
#include "Manager.h"
using namespace std;

int main()
{
    // Implicitly converts from Manager to Employee.
    // A manager is an employee.
    Employee *emp = new Manager("Mary");
    cout << emp->get_name() << endl;

    // Explicitly converts from Employee to Manager.
    // This employee happens to be a manager.
    Employee *mgr = dynamic_cast<Manager *>(emp);
    if (mgr != NULL) cout << mgr->get_name() << endl;
    else             cout << "Invalid cast!" << endl;

    // An invalid cast. This employee is not a manager.
    emp = new Employee("Ron");
    mgr = dynamic_cast<Manager *>(emp);
    if (mgr != NULL) cout << mgr->get_name() << endl;
    else             cout << "Invalid cast!" << endl;

    return 0;
}
